VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   5340
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   5295
   LinkTopic       =   "Form1"
   ScaleHeight     =   5340
   ScaleWidth      =   5295
   StartUpPosition =   3  'Windows Default
   Begin VB.CheckBox chkSnapToGrid 
      Caption         =   "Grid"
      Height          =   255
      Left            =   120
      TabIndex        =   1
      Top             =   120
      Width           =   735
   End
   Begin VB.PictureBox picCanvas 
      Height          =   2415
      Left            =   120
      ScaleHeight     =   2355
      ScaleWidth      =   4275
      TabIndex        =   0
      Top             =   240
      Width           =   4335
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Declare Function Polygon Lib "gdi32" (ByVal hdc As Long, lpPoint As POINTAPI, ByVal nCount As Long) As Long
Private Type POINTAPI
    X As Long
    Y As Long
End Type

Private Const GRID_SPACING As Integer = 10

' The grab handle we are dragging. This is
' -1 when we are not dragging any handle.
Private m_DraggingHandle As Integer

' The data points.
Private m_Points() As POINTAPI

Private Const HANDLE_WIDTH As Integer = 6
Private Const HANDLE_HALF_WIDTH As Integer = HANDLE_WIDTH \ 2

Private Const GRID_WID As Integer = 10

Private Sub chkSnapToGrid_Click()
    picCanvas.Refresh
End Sub

Private Sub Form_Load()
    ' Not dragging any handle.
    m_DraggingHandle = -1

   ' Create some initial point data.
    ' Make room.
    ReDim m_Points(1 To 5)

    ' Set initial points.
    m_Points(1).X = 67: m_Points(1).Y = 189
    m_Points(2).X = 62: m_Points(2).Y = 111
    m_Points(3).X = 123: m_Points(3).Y = 100
    m_Points(4).X = 190: m_Points(4).Y = 183
    m_Points(5).X = 130: m_Points(5).Y = 214

    picCanvas.ScaleMode = vbPixels
End Sub


' Draw the polygon.
Private Sub DrawPolygon(ByVal pic As PictureBox)
Dim X As Integer
Dim Y As Integer
Dim i As Integer

    ' Draw the grid if necessary.
    If chkSnapToGrid.Value = vbChecked Then
        For X = 0 To picCanvas.ScaleWidth Step GRID_WID
            For Y = 0 To picCanvas.ScaleHeight Step GRID_WID
                picCanvas.PSet (X, Y), vbBlack
            Next Y
        Next X
    End If

    ' Draw the polygon.
    pic.FillStyle = vbFSSolid
    pic.FillColor = RGB(&H70, &HFF, &H80)
    pic.ForeColor = RGB(0, 0, 256)
    Polygon pic.hdc, m_Points(1), UBound(m_Points) - LBound(m_Points) + 1

    ' Draw grab handles as white squares with black edges.
    For i = LBound(m_Points) To UBound(m_Points)
        pic.FillStyle = vbFSSolid
        pic.FillColor = vbWhite
        pic.ForeColor = vbBlack
        pic.Line (m_Points(i).X - HANDLE_HALF_WIDTH, m_Points(i).Y - HANDLE_HALF_WIDTH)-Step(HANDLE_WIDTH, HANDLE_WIDTH), , B
    Next i
End Sub

Private Sub Form_Resize()
    picCanvas.Move 0, 0, ScaleWidth, ScaleHeight
End Sub

' Grab a handle.
Private Sub picCanvas_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
Dim dx As Single
Dim dy As Single
Dim i As Integer

    For i = LBound(m_Points) To UBound(m_Points)
        If Abs(m_Points(i).X - X) < HANDLE_HALF_WIDTH And _
           Abs(m_Points(i).Y - Y) < HANDLE_HALF_WIDTH _
        Then
            ' We are over this grab handle.
            ' Start dragging.
            m_DraggingHandle = i
            picCanvas.MousePointer = vbCrosshair
            Exit For
        End If
    Next i
End Sub

' Move the drag handle.
Private Sub picCanvas_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    ' Do nothing if we are not dragging.
    If m_DraggingHandle = -1 Then Exit Sub

    ' Snap to grid.
    If chkSnapToGrid.Value = vbChecked Then
        X = GRID_WID * CInt(X / GRID_WID)
        Y = GRID_WID * CInt(Y / GRID_WID)

        ' Don't redraw if the point hasn't moved.
        If (m_Points(m_DraggingHandle).X = X) And _
           (m_Points(m_DraggingHandle).Y = Y) Then Exit Sub
    End If

    ' Move the handle.
    m_Points(m_DraggingHandle).X = X
    m_Points(m_DraggingHandle).Y = Y

    ' Redraw.
    picCanvas.Cls
    picCanvas.Refresh
End Sub

' Stop dragging.
Private Sub picCanvas_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    picCanvas.MousePointer = vbDefault
    m_DraggingHandle = -1
End Sub


Private Sub picCanvas_Paint()
    DrawPolygon picCanvas
End Sub


